<?php

class CloudController extends Controller
{
  
    public function actionCheck ()
    {   

        if (!isset ($_POST)) {
            die ('Error: Не переданы параметры');
        }
       
        $request = $_POST;
       
        $api_pass = Settings::item ('cloudPass');
        $order_id = $request['InvoiceId'];     
            
        $accesskey = trim($api_pass);       

        if($this->CheckHMac($accesskey))
        {
            $data['CODE'] = 0;
        }
        else
        {
            $data['CODE']=5204;            
        }
        echo json_encode($data);
        die();       

    }
    
    public function actionIndex ()
    {  	

        if (!isset ($_POST)) {
            die ('Error: Не переданы параметры');
        }
		$request = $_POST;

		// пароль из админки
		$api_pass = Settings::item ('cloudPass');
		$order_id = $request['InvoiceId'];

		$bill_id = $order_id;
		$sum = $request['Amount'];
		$type = 'rur'; //Валюта - рубли
		$way = 'CloudPayments';
		Bill::payBill($bill_id, $way, $sum, $type);

	    $data['CODE'] = 0;
	    echo json_encode($data);
	    die();
		
    }

    public function actionOk ()
    {
        $this->redirect (Y::bu().'f/ok/w/cloud');
    }

    public function actionFail ()
    {
        $this->redirect (Y::bu().'f/fail/w/cloud');
    }

    public function actionTest ()
    {
        die ('Test OK');
    }

    private function convertToUTF8($str) {
        $enc = mb_detect_encoding($str);

        if ($enc && $enc != 'UTF-8') {
            return iconv($enc, 'UTF-8', $str);
        } else {
            return $str;
        }
    }

    private function jsonEncode ($json)
    {
        $encoded = json_encode($json);
        $unescaped = preg_replace_callback('/\\\\u(\w{4})/', function ($matches) {
            return html_entity_decode('&#x' . $matches[1] . ';', ENT_COMPAT, 'UTF-8');
        }, $encoded);        

        return $unescaped;
    }


    private function CheckHMac($APIPASS)   //ok  
    {
        $headers = $this->detallheaders();   
                        
        if (isset($headers['Content-HMAC']) || isset($headers['Content-Hmac'])) 
        {            
            $message = file_get_contents('php://input');
            $s = hash_hmac('sha256', $message, $APIPASS, true);
            $hmac = base64_encode($s);             
            
            if ($headers['Content-HMAC']==$hmac) return true;
            else if($headers['Content-Hmac']==$hmac) return true;                                    
        }
        else return false;
    }
    
    private function detallheaders()  ///OK
    {
        if (!is_array($_SERVER)) {
            return array();
        }
        $headers = array();
        foreach ($_SERVER as $name => $value) {
            if (substr($name, 0, 5) == 'HTTP_') {
                $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
            }
        }
        return $headers;
    }

}
?>