<?php

class PaytodoController extends Controller
{  

    public $apiKey = '';
    public $secretKey = '';
    public $apiUrl = 'https://api.pay2me.world';
    private $apiVersion = 'v3';

    public function __construct(){
        $this->apiKey = Settings::item("payTodoApi");
        $this->secretKey = Settings::item("payTodoSecret");
    }

    public function actionForm ()
    {
      
            header ("Content-type: text/html; charset=utf-8");
            if (!$_POST)
            {
                die ('Неизвестная ошибка, вернитесь обратно и нажмите, пожалуйста, ещё раз кнопку Продолжить оплату');            
            }
            
            if (!isset($_POST['bill_id']))
            {
                die ('Неизвестная ошибка, вернитесь обратно и нажмите, пожалуйста, ещё раз кнопку Продолжить оплату');            
            } 

            $bill_id = (int) $_POST['bill_id'];

            $b = Bill::model()->findByPk ($bill_id);
            
            //Если не найден - ошибка
            if (!$b)
            {
                die ('Невозможно найти счёт. Вернитесь, пожалуйста, обратно или начните процесс заказа заново.');            
            }
            $ceny = Valuta::conv($b->sum, $b->valuta, $b->usdkurs, $b->eurkurs, $b->uahkurs);        

            $bu = Y::bu();

            $rur = number_format($ceny['rur'],  2, '.', '');       

            $order_desc = $_POST['desc'];

            $response = $this->dealCreate($bill_id, $order_desc, $rur, $bu);

            //print_r($response);
         
              echo '<script>
                        document.location.href="'.$response->redirect.'"
                    </script>';
          
            die ();     
    }


    //Оповещение от платёжной системы Yandex
    public function actionIndex ()
    {

    	$filename = __DIR__ .'/array.txt';
		// Запись.
		$data = serialize($_REQUEST);      // PHP формат сохраняемого значения.
		//$data = json_encode($bookshelf);  // JSON формат сохраняемого значения.
		file_put_contents($filename, $data);
	

		/*$_REQUEST['create_date']="2020-09-02T10:57:19.11Z";
        $_REQUEST['expire_date']="2021-08-28T10:57:19.11Z";
        $_REQUEST['object_id']="2b419e0412d23f1e12aa67eb5e9ed100";
        $_REQUEST['order_desc']="PAY #8";
        $_REQUEST['order_fulldesc']="PAY #8";
        $_REQUEST['order_id']="8";
        $_REQUEST['redirect']="https://api.pay2me.world/api/v3/deals/2b419e0412d23f1e12aa67eb5e9ed100/";
        $_REQUEST['status']="paid";
        $_REQUEST['update_date']="2020-09-02T10:58:04.157Z";
        $_REQUEST['order_amount']="10";
        $_REQUEST['signature']="7278ad24af1a1dcec8fd10d71f260121";
        $_REQUEST['paid_date']="2020-09-02T10:58:03";
        $_REQUEST['id']="552081";*/



        $_REQUEST = $_REQUEST;
        $MNT_TRANSACTION_ID = $_REQUEST['order_id'];
        if (isset($_REQUEST['signature'])&&isset($_REQUEST['status'])) {
        
            $signature = $this->getSignature(array(
                        "create_date" => $_REQUEST['create_date'],
                        "expire_date" => $_REQUEST['expire_date'],
                        "object_id" => $_REQUEST['object_id'],
                        "order_desc" => $_REQUEST['order_desc'],
                        "order_fulldesc" => $_REQUEST['order_fulldesc'],
                        "order_id" => $_REQUEST['order_id'],
                        "redirect" => $_REQUEST['redirect'],
                        "status" => $_REQUEST['status'],
                        "update_date" => $_REQUEST['update_date'],
                        "order_amount" => $_REQUEST['order_amount'],
                        "paid_date" => $_REQUEST['paid_date'],
                        "id" => $_REQUEST['id'],
                    )
                );

            print_r($signature);
            if ($_REQUEST['signature'] == $signature) {
                if($_REQUEST['status']=="paid"){
                    $bill_id = intval ($_REQUEST['order_id']); //Тот же номер счёта, но как число - для зачисления оплаты
                    $way = 'Paytodo';
                    $sum = $_REQUEST['order_amount'];
                    $type = 'rur';

                    Bill::payBill($bill_id, $way, $sum, $type, 'Paytodo');
                    die ('SUCCESS');     
                }
                else
                {
                   die ('FAIL');   
                }
            }
            else
            {
                 die ('FAIL');    
            }
        }
        else
        {
             die ('FAIL2');  
        }
    }

    public function actionOk ()
    {
        $this->redirect (Y::bu().'f/ok/w/paytodo');
    }

    public function actionFail ()
    {
        $this->redirect (Y::bu().'f/fail/w/paytodo');
    }

    public function actionTest ()
    {
        die ('Test OK');
    }



    public function dealCreate($order_id, $order_desc, $order_amount, $order_return) {
        return $this->transport('/api/'.$this->apiVersion.'/deals',["order_id" => $order_id, "order_return" => $order_return, "order_desc" => $order_desc, "order_amount" => $order_amount]);
    }


    public function dealStatus($object_id) {
        return $this->transport('/api/'.$this->apiVersion.'/deals/status/'.$object_id,[],'GET');
    }

    public function dealComplete($object_id) {
        return $this->transport('/api/'.$this->apiVersion.'/deals/complete/'.$object_id,[],'PUT');
    }


    public function dealsComplete($object_ids=[]) {
        return $this->transport('/api/'.$this->apiVersion.'/deals/complete',['deals'=>$object_ids],'PUT');
    }


    public function dealCancel($object_id) {
        return $this->transport('/api/'.$this->apiVersion.'/deals/cancel/'.$object_id,[],'PUT');
    }


    public function transport($path, $params=[],$method='POST') {
        $params['signature'] = $this->getSignature($params);
        $data_string = json_encode($params);
        $curl = curl_init($this->apiUrl.$path);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            'X-API-KEY: '.$this->apiKey,
            'Accept: application/json',
        ));

        $json = curl_exec($curl);
        $result = json_decode($json);

        return $result;
    }


    private function getSignature($params=array()) {

        ksort($params);
        $a = array();
        foreach ($params as $key => $val) {
            $a[]=$val;
        }
        print_r($a);
        return md5(implode("", $a).$this->secretKey);
    }

}
?>